(function(){
var _verbose = false;

var c2Runtime;

var step = -1;
var started = false;
var audioBuffer = [];
var timerUpdate;


var listOfAllSong = ["321_1.ogg","321_2.ogg","321_fight.ogg","attack_effect.ogg","attack_effect_1.ogg","attack_effect_2.ogg","attack_effect_3.ogg","bodyfall_sound.ogg","brutality_phase_1.ogg","brutality_phase_2.ogg","butt_level.ogg","butt_menu.ogg","die_boss0.ogg","die_boss1.ogg","die_boss2.ogg","die_boss3.ogg","die_boss4.ogg","die_boss5.ogg","die_enemy2_1.ogg","die_enemy2_2.ogg","die_enemy3_1.ogg","die_enemy3_2.ogg","die_enemy3_3.ogg","die_enemy4_1.ogg","die_enemy4_2.ogg","die_enemy5_1.ogg","die_enemy5_2.ogg","die_enemy6_1.ogg","die_enemy6_2.ogg","dog_attack.ogg","dog_run_sound.ogg","enemy_rotate.ogg","faux.ogg","fight_hammer1.ogg","fight_hammer2.ogg","fight_punch1.ogg","fight_punch2.ogg","fight_punch3.ogg","fight_punch4.ogg","fight_punch5.ogg","fight_punch_boss1.ogg","fight_punch_boss2.ogg","fight_punch_boss3.ogg","fight_punch_boss4.ogg","fight_sprotch.ogg","fight_the_boss_1.ogg","fight_the_boss_2.ogg","fight_weapon_broke.ogg","fight_woosh1.ogg","fight_woosh2.ogg","fight_woosh3.ogg","gameover_healthbarup.ogg","ghost_fly.ogg","gloves_logo_sound.ogg","hit_blueninja_1.ogg","hit_blueninja_2.ogg","hit_boss0_1.ogg","hit_boss0_2.ogg","hit_boss0_3.ogg","hit_boss1_1.ogg","hit_boss1_2.ogg","hit_boss1_3.ogg","hit_by_punch_1.ogg","hit_by_punch_2.ogg","hit_by_punch_3.ogg","hit_by_punch_4.ogg","hit_enemy2.ogg","hit_enemy4.ogg","hit_shuriken_1.ogg","hit_shuriken_2.ogg","hit_shuriken_3.ogg","hit_the_enemy_1.ogg","hit_the_enemy_2.ogg","hit_the_enemy_3.ogg","hit_whiteninja_1.ogg","hit_whiteninja_2.ogg","jackpot.ogg","moving_head_logo_sound.ogg","music_critical.ogg","music_ingame.ogg","music_menu.ogg","mysteriousweapon_boum.ogg","newrecord.ogg","no_money.ogg","phoenix.ogg","player_attack_perfect.ogg","player_die.ogg","player_hit1.ogg","player_hit2.ogg","player_throw_grenade.ogg","player_throw_grenade_explosion.ogg","player_ya1.ogg","player_ya10.ogg","player_ya11.ogg","player_ya2.ogg","player_ya3.ogg","player_ya4.ogg","player_ya5.ogg","player_ya6.ogg","player_ya7.ogg","player_ya8.ogg","player_ya9.ogg","revivalepicburstinyourface.ogg","rip_cloth_1.ogg","rip_cloth_2.ogg","rip_cloth_3.ogg","rip_cloth_4.ogg","roulette_slot.ogg","roulette_tone_1.ogg","roulette_tone_2.ogg","roulette_tone_3.ogg","shine_weapon_sound.ogg","show_me_roulette.ogg","swordscrape.ogg","sword_weapon.ogg","throw_bottle_1.ogg","throw_bottle_2.ogg","throw_boxingbag_1.ogg","throw_boxingbag_2.ogg","throw_boxingbag_3.ogg","throw_chair_1.ogg","throw_chair_2.ogg","throw_chair_3.ogg","title_logo_sound.ogg","victorytoolcoin.ogg","victory_coin.ogg","victory_game_over.ogg","victory_star.ogg","victory_win.ogg","weapon_punch_1.ogg","weapon_punch_2.ogg","weapon_punch_3.ogg","wolfhit.ogg","wolfmode.ogg","wolfshoot.ogg","wrong.ogg"];
var category_list = [];

fillArrayCategory();

eventToFire.registerEvent("c2LayoutChange",
	function (args){
		if(!started){
			c2Runtime = cr_getC2Runtime();
			started = true;
			nextStep();
		}
	}
);

function update(){
	for (var i = 0; i < audioBuffer.length; i++) {
		if(audioBuffer[i].isLoadedAndDecoded()){ //audioBuffer[i].isLoaded()
			if(_verbose) console.log("sound end load & decoded:",audioBuffer[i].src);
			audioBuffer.splice(i, 1);
		}
	};

	if(audioBuffer.length == 0){
		nextStep();
	}
}

function nextStep(){
	step +=1;
	clearInterval(timerUpdate);

	if(category_list[step]){
		for (var i = category_list[step].length - 1; i >= 0; i--) {
			if(_verbose) console.log("sound start load:",category_list[step][i]);
			audioBuffer.push(c2Runtime.audioInstance.getAudioBuffer(c2Runtime.files_subfolder+category_list[step][i]));
		};

		timerUpdate = setInterval(update,100);

	}else{
		if(_verbose) console.log("all Sound loaded & decoded");
	}
}

function fillArrayCategory(){
	var firstLoad = [];
	var arrayWihtoutMusic = [];
	var musicInGame = [];
	var musicGameOver = [];
	var name;

	for (var i = 0; i < listOfAllSong.length; i++) {
		name = listOfAllSong[i].replace(/\.[a-z]+/,"");
		
		if(name == "butt_level" || name == "butt_menu" || name == "music_menu"){
			firstLoad.push(listOfAllSong[i]);
		}
		else if(name == "music_ingame"){
			musicInGame.push(listOfAllSong[i]);
		}
		//list of gameOverSong
		else if(name == "music_game_over" || name == "defeat_sound" || name == "defeat" || name == "victory_game_over" || name == "looser" || name == "gameOver_defeat" || name == "gameOver"){
			musicGameOver.push(listOfAllSong[i]);
		}
		else {
			arrayWihtoutMusic.push(listOfAllSong[i]);
		}
	};
	category_list.push(firstLoad);
	category_list.push(arrayWihtoutMusic);
	category_list.push(musicInGame);
	category_list.push(musicGameOver);
}

}())

